#ifndef _DEF_CAMERA
#define _DEF_CAMERA

#include "vec.h"
#include "debug.h"

typedef struct Camera
{
	Vec pos;
	Vec *target; /* the target position to lerp on */
	float speed; /* camera lerp speed with 0 < speed <= 1 */
} Camera;

void camera_step(Camera *camera);
#ifdef DEBUG
/* draw a dot corresponding to camera position */
void camera_draw(Camera *camera);
#endif

#endif /* _DEF_CAMERA */
